% December 2019
% Developed by TeSA and CNES (France, Toulouse)
% contact
%   corinne.mailhes@tesa.prd.fr
%   amandine.guillot@cnes.fr
%
% Description : simulated SLA generation with (optional) trend
% --------------------
% Necessary function
%      generation_signal_simule_SLA
% --------------------
% En entree :   % Simu : structure contenant les parametres de simulation
%%%%%% MAI 2019 - rajout explications
%%%%%% Simu.NSamples, .NSegments, .NIters, .FMin, .Fcross, .Slope,
%%%%%% .NoiseLevel, .Dist, .repexdetrend
% --------------------
% En sortie :
    % NbSeg = Nombre de segments
    % NbPts = Nombre de points par segment
    % vSLA : signal
    % F_true = pour generer directement d'autres echantillons (methode = 1)
    % Sx_true : spectre theorique et le vecteur de frequences
% --------------------
function [NbSeg,NbPts,vSLA,F_true,Sx_true] = generation_signal_bruit_simule_SLA(Simu)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%rng default;  % For debug 
 Fe = 1/Simu.Dist; % frequence d'echantillonnage en km-1
 NbPts=Simu.NSamples; 
 NbSeg=Simu.NSegments;
 SLA = zeros(NbPts, NbSeg);
 [~,G_true, Sx_true, F_true] = generation_signal_simule_SLA(NbPts,Simu.FMin,Simu.Fcross,Simu.Slope,Simu.NoiseLevel, Fe,1); % methode des correlations
     
    
 %Generate signal
 for n=1:NbSeg
    SLA(1 : NbPts, n) = G_true * randn(NbPts,1);
 end
   
 if Simu.repexdetrend == 1 | Simu.repexdetrend ==2,
     % 3 lignes suivantes moved here because file unnecessary if
     % repexdetrend = 0
     load Exdetrend; % 290 segments de tendances lineaires de 3000 echantillons chacun
     ndetrend = 1; % numero du 1er segment a considerer dans Exdetrend.mat
     ndetrendmax = length(exdetrend)/ NbPts;  
        % rajout du detrend simule
        ndetrend = unidrnd(ndetrendmax,1,1); %0;
        for n=1:NbSeg
             %ndetrend = unidrnd(ndetrendmax,1,1);
             ndetrend = ndetrend + 1;
             if ndetrend > ndetrendmax, ndetrend = 1; end
             if Simu.repexdetrend == 1
                 SLA(1 : NbPts, n) = SLA(1 : NbPts, n) + exdetrend((ndetrend-1)*NbPts + 1 : (ndetrend-1)*NbPts + NbPts)'; % rajout du segment
             else
                 SLA(1 : NbPts, n) = SLA(1 : NbPts, n) + mean(exdetrend((ndetrend-1)*NbPts + 1 : (ndetrend-1)*NbPts + NbPts)); % rajout de la moyenne du segment
             end
        end
 end
 N = NbSeg*NbPts; % nombre de points du signal complet
 vSLA = reshape(SLA,1,N);    % transformation de la matrice SLA en un vecteur
end

