% December 2019
% Developed by TeSA and CNES (France, Toulouse)
% contact
%   corinne.mailhes@tesa.prd.fr
%   amandine.guillot@cnes.fr
%
% Description : return des index de debuts et de fin dans un tableau de
% frequence par raport a des valeurs frequentielles
% --------------------
% Fonctions appelees (en dehors des fonctions matlab) :
%      aucune
% --------------------
% En entree :
    % freqLimits = frequences debut et fin
    % tab_log_fnorm = tableau de frequences
% --------------------
% En sortie :
    % ind_linreg = index dans le tableau des frequences debut et fin
% --------------------
function  ind_linreg = get_index_norm(freqLimits,tab_log_fnorm)
fnorm_begin_linreg = freqLimits(1) ; %normalized frequency
log_fnorm_begin_linreg = log(fnorm_begin_linreg);
[~,ind_begin_linreg] = min(abs(tab_log_fnorm-log_fnorm_begin_linreg));
fnorm_end_linreg = freqLimits(2);
log_fnorm_end_linreg = log(fnorm_end_linreg);
[~,ind_end_linreg] = min(abs(tab_log_fnorm-log_fnorm_end_linreg));
ind_linreg = (ind_begin_linreg:ind_end_linreg);
end

