% December 2019
% Developed by TeSA and CNES (France, Toulouse)
% contact
%   corinne.mailhes@tesa.prd.fr
%   amandine.guillot@cnes.fr
%
function [sortie]=warping(y,L,b)

% y : signal original
% b : param?tre de Laguerre


% Cette fonction retourne un signal sortie de L points dont le spectre a subi une 
% transformation sur l'axe des frequences par rapport au signal par 
% decomposition sur la base de Laguerre.
N=size(y,2);
lig=size(y,1);
if lig~=1
    y = y';
    N=size(y,2);
end;

% *********************************************************** %
% ************* Operations de filtrage par A(z) ************* %
% *********************************************************** %
num_A=[-b 1];
deno_A=[1 -b];


fy=fliplr(y);

c=sqrt(1-b^2)*filter(1,deno_A,fy);


U=c;
sortie=zeros(1,L);
sortie(1)=c(N);

for j=2:L,
	U=filter(num_A,deno_A,U);
    sortie(j)=U(N);
end

% On retourne le signal de la derniere colonne de U a cause du
% transitoire lie aux retards des l filtres.

